﻿namespace RFTiming
{
    class Formatter
    {
        public Formatter(RuntimeFlowExt.IEngine engine)
        {
            this.engine = engine;
        }

        public string FormatFunctionCall(System.DateTime time, uint threadID, uint functionID, uint paramsID, int currentStackDepth)
        {
            return time.ToString("H:mm:ss.fff") + string.Format(" [{0,5}] ", threadID) +
                (new string(' ', currentStackDepth)) + FunctionName(functionID);
        }

        private string FunctionName(uint functionID)
        {
            RuntimeFlowExt.FunctionInfo functionInfo = engine.GetFunctionInfo(functionID);
            return functionInfo.className + (functionInfo.className.Length > 0 ? "." : "") + functionInfo.functionName;
        }

        private RuntimeFlowExt.IEngine engine;
    }
}
